package de.tu_darmstadt.tk.SmartHomeNetworkSim.core;

import java.util.Collection;

/**
 * Connection between two or more SmartDevices, which sends packages according to a specified protocol
 * 
 * @author Andreas T. Meyer-Berg
 */
public interface Connection {
	
	/**
	 * Returns the Link, which the connection uses
	 * @return
	 */
	public Link getLink();
	
	/**
	 * Returns the SmartDevice which started this connection
	 * @return source SmartDevice
	 */
	public SmartDevice getSource();
	
	/**
	 * Simulate Time Step
	 * @param startTime
	 * @param duration
	 * @return packets that were sent
	 */
	public Collection<Packet> simulateTimeIntervall(long startTime, long duration);
}
