package de.tu_darmstadt.tk.SmartHomeNetworkSim.core;

import java.util.Collection;
import java.util.LinkedList;

public class SimpleConnection implements Connection {

	SmartDevice source;
	SmartDevice destination;
	Link link;
	Protocol p;
	
	public SimpleConnection(SmartDevice src, SmartDevice dest, Link link, Protocol p) {
		source = src;
		destination = dest;
		this.link = link;
		this.p = p;
	}
	@Override
	public Link getLink() {
		return link;
	}

	@Override
	public Collection<Packet> simulateTimeIntervall(long startTime, long duration) {
		LinkedList<Packet> list = new LinkedList<Packet>();
		for(long i = 0; i<duration; i+=100)
			list.add(p.generateNextPaket(startTime+i));
		return list;
	}
	@Override
	public SmartDevice getSource() {
		return source;
	}

}
