package de.tu_darmstadt.tk.SmartHomeNetworkSim.core;

/**
 * Simple Implementation of a protocol, which sends 
 *
 * @author Andreas T. Meyer-Berg
 */
public class SimpleProtocol implements Protocol {

	/**
	 * Source of the protocol, and destination which responds
	 */
	SmartDevice source, destination;
	
	/**
	 * True if the next Package is send by source, false if the next one will be send by destination
	 */
	boolean srcSends;
	
	public SimpleProtocol(SmartDevice src, SmartDevice dest){
		source = src;
		destination = dest;
		srcSends = true;
	}
	@Override
	public Packet generateNextPaket(long timestep) {
		srcSends = !srcSends;
		if(srcSends)
			return new SimplePacket(timestep, destination, source);
		else
			return new SimplePacket(timestep, source, destination);
	}

}
