package de.tu_darmstadt.tk.SmartHomeNetworkSim.core;

/**
 * Manages the Simulation by calling the relevant methods.
 *
 * @author Andreas T. Meyer-Berg
 */
public class SimulationManager {
	Model model;

	/**
	 * creates a new Simulationmanger
	 * 
	 * @param model
	 */
	public SimulationManager(Model model) {
		this.model = model;
	}

	/**
	 * Simulates one time step
	 * 
	 * @param startTime
	 * @param duration
	 */
	public void simulateTimeIntervall(long startTime, long duration){
		//Simulate all Links, and their connections
		model.getConnectionNetworks().forEach(d -> d.simulateTimeIntervall(startTime, duration));
		//Simulate SmartDevices - if they need some logic
		model.getDevices().forEach(d -> d.simulateTimeStep(startTime, duration));
		//Store Packages/Export Packages etc. 
		model.getConnectionNetworks().forEach(d->d.getPackets()
				.forEach(p-> 
				{
					if(p == null)
						System.out.println("Packet: Null");
					else 
						System.out.println(p.getTextualRepresentation());
				}));
		
		
	}
}
